import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class perland extends PApplet {/*
complexity
smoothness
scale
sea level
mountainousness
*/


int mywidth = 512;
int myheight = 512;
int xoffset=1000;
int yoffset=1000;
float persistence=.5f;
int octaves=8;
float submerge=120;
float noiseVal;
float noiseScale=0.005f;
float elevfact=2;
HScrollbar hs1, hs2, hs3, hs4, hs5;
PFont font = createFont("FFFAliasCondensed",8); 
  
public void setup() {


 // Define and create rectangle button
size(mywidth+200,myheight);
textFont(font); 
fill(204, 102, 0); 
text("Click here to view map.", 15, 50); 
text("Layers", width-180, 15);
text("Impact", width-180, 35);
text("Scale", width-180, 55);
text("Sea Level", width-180, 75);
text("Erosion", width-180, 95);

text("Adjust the sliders, and click the map to see it refreshed. Layers: the number of levels of detail. A higher value means rougher land. Impact: the amount of impact that successive layers of complexity will have. If Layers has a low value, Impact will have little effect. Scale: the amount of stretch on the landscape. Increasing this value will produce tighter landmasses. Sea level: increasing this value decreases the amount of land above sea level. Erosion: Decreases the overall mountainousness. Use a low value for mountainous terrain. You can also use the arrow keys to nudge the map 10px in any direction.", width-190, 120, 180, 1000);


 hs1 = new HScrollbar(mywidth, 20, 200, 10, 1);
 hs2 = new HScrollbar(mywidth, 40, 200, 10, 1);
 hs3 = new HScrollbar(mywidth, 60, 200, 10, 1);
 hs4 = new HScrollbar(mywidth, 80, 200, 10, 1);
 hs5 = new HScrollbar(mywidth, 100, 200, 10, 1);
}

public void draw() {
 hs1.update();
 hs2.update();
 hs3.update();
 hs4.update();
   hs5.update();
 hs1.draw();
 hs2.draw();
 hs3.draw();
 hs4.draw();
  hs5.draw();
//update values
persistence = ((hs1.getPos()-(width-200))/400);
octaves = floor(((hs2.getPos()-(width-200))/200)*16);
noiseScale = ((hs3.getPos()-(width-200))/200)*.03f*256/mywidth;
submerge = ((hs4.getPos()-(width-200))/200)*300;
elevfact = floor(((hs5.getPos()-(width-200))/200)*15)+1;

//evalfact isn't working

if(mousePressed) {
  if (mouseX<mywidth){
  println(noiseScale);
     println(noiseScale/myheight);
  for(int y=0; y<myheight; y++) {
   for(int x=0; x<mywidth; x++) {
     noiseDetail(octaves, persistence);
     noiseVal=noise(
       (x+xoffset)*noiseScale,
       (y+yoffset)*noiseScale
     );
    float elev = (noiseVal*(255+submerge))-submerge;

    elev = elev/elevfact;
     if (elev < 1) {
     //stroke(elev);
     stroke(0,0,100);
     } else {
     //stroke(elev);
     stroke(elev, 50+elev, elev);
     }
     point(x,y);
   }
 }


  }
 }

}

class HScrollbar
{
 int swidth, sheight;    // width and height of bar
 int xpos, ypos;         // x and y position of bar
 float spos, newspos;    // x position of slider
 int sposMin, sposMax;   // max and min values of slider
 int loose;              // how loose/heavy
 boolean over;           // is the mouse over the slider?
 boolean locked;
 float ratio;

 HScrollbar (int xp, int yp, int sw, int sh, int l) {
   swidth = sw;
   sheight = sh;
   int widthtoheight = sw - sh;
   ratio = (float)sw / (float)widthtoheight;
   xpos = xp;
   ypos = yp-sheight/2;
   spos = xpos + swidth/2 - sheight/2;
   newspos = spos;
   sposMin = xpos;
   sposMax = xpos + swidth - sheight;
   loose = l;
 }

 public void update() {
   if(over()) {
     over = true;
   } else {
     over = false;
   }
   if(mousePressed && over) {
     locked = true;
   }
   if(!mousePressed) {
     locked = false;
   }
   if(locked) {
     newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
   }
   if(abs(newspos - spos) > 1) {
     spos = spos + (newspos-spos)/loose;
   }
 }

 public int constrain(int val, int minv, int maxv) {
   return min(max(val, minv), maxv);
 }

 public boolean over() {
   if(mouseX > xpos && mouseX < xpos+swidth &&
   mouseY > ypos && mouseY < ypos+sheight) {
     return true;
   } else {
     return false;
   }
 }

 public void draw() {
   fill(255);
   rect(xpos, ypos, swidth, sheight);
   if(over || locked) {
     fill(153, 102, 0);
   } else {
     fill(102, 102, 102);
   }
   rect(spos, ypos, sheight, sheight);
 }

 public float getPos() {
   // convert spos to be values between
   // 0 and the total width of the scrollbar
   return spos * ratio;
 }
}


 // save IMAGE hacked by Martin and Koenie rehacked by Watz
 
public void saveFrame(String filename) {
BufferedImage img=new BufferedImage(height, height,
BufferedImage.TYPE_INT_RGB);
loadPixels();
img.setRGB(0, 0, height, height, g.pixels, 0, width);

String extn=filename.substring(filename.lastIndexOf('.')+1).toLowerCase();
if(extn.equals("jpg")||extn.equals("png")) { // add here as needed
 try {
   javax.imageio.ImageIO.write(img, extn, new File(savePath(filename)));
   println("saved "+filename);
 }
 catch(Exception e) {
   System.err.println("error while saving as "+extn);
   e.printStackTrace();
 }
}
else {
 super.saveFrame(filename);
}
}

public void keyPressed() {
 //if(key == CODED) {
 switch (keyCode) {

    case UP:
    println("up");
    yoffset-=10;
    break;
   case DOWN:
      println("down");
      yoffset+=10;
      break;
    case RIGHT:
      println("right");
      xoffset-=10;
      break;
      case LEFT:
      println("left");
      xoffset+=10;
      break;
      case ENTER:
      println("enter");
         saveFrame("perland.png");
         break;
   }
 //}
}

/*This random map generator uses perlin code.
To begin, click the grey area to the left of the sliders; a map appears (may
take several seconds);
Use the sliders to adjust the amount of change you want to the land.
When you are finished adjusting the sliders, click the map to refresh and
see your changes

The Sliders:
1. complexity: the number of levels of detail. A higher value means rougher
land.
2. impact: the amount of impact that successive layers of complexity will
have.
 If #1 has a low value, #2 will have little effect.
3. Scale: the amount of stretch on the landscape. Increasing this value will
produce
 tighter landmasses.
4. Sea level: increasing this value decreases the amount of land above sea
level.
5. Erosion: Decreases the overall mountainousness. Use a low value for
mountainous terrain.

You can also use the arrow keys to nudge the map 10px in any direction.

*/
static public void main(String args[]) {   PApplet.main(new String[] { "perland" });}}